-- gametype-specific code goes here

if not SSC then -- don't redefine for sm-ssc
	-- GameCompatibleModes() - returns a list of valid style types for current game.
	function GameCompatibleModes()
		sGame = GAMESTATE:GetCurrentGame():GetName();
		local Modes = {
			dance = "Single,Double,Solo,Versus,Couple",
			pump = "Single,Double,HalfDouble,Versus,Couple",
			beat = "5Keys,7Keys,10Keys,14Keys",
			kb7 = "KB7",
			para = "Single",
			lights = "Single", -- lights shouldn't be playable
		};
		return Modes[sGame];
	end

	--[[ Gameplay functions ]]

	-- ComboContinue() - determines when the combo should continue
	function ComboContinue()
		sGame = GAMESTATE:GetCurrentGame():GetName();
		local Continue = {
			dance = GAMESTATE:GetPlayMode() == "PlayMode_Oni" and "TapNoteScore_W2" or "TapNoteScore_W3",
			pump = "TapNoteScore_W4",
			beat = "TapNoteScore_W3",
			kb7 = "TapNoteScore_W3",
			para = "TapNoteScore_W4",
		};
		return Continue[sGame]
	end;

	-- ComboContinue() - determines when the combo should be maintained
	function ComboMaintain()
		sGame = GAMESTATE:GetCurrentGame():GetName();
		local Maintain = {
			dance = "TapNoteScore_W3",
			pump = "TapNoteScore_W4",
			beat = "TapNoteScore_W3",
			kb7 = "TapNoteScore_W3",
			para = "TapNoteScore_W4",
		};
		return Maintain[sGame]
	end;
end; -- if not sm-ssc