if not SSC then
	-- sm-ssc branch overlay for regular SM4 since we do branches differently
	-- used for various SMOnline-enabled screens:
	function SMOnlineScreen()
		for pn in ivalues(GAMESTATE:GetHumanPlayers()) do
			if not IsSMOnlineLoggedIn(pn) then return "ScreenSMOnlineLogin" end;
		end;
		return "ScreenNetRoom"
	end;

	function SelectMusicOrCourse()
		if IsNetSMOnline() then
			return "ScreenNetSelectMusic";
		elseif GAMESTATE:IsCourseMode() then
			return "ScreenSelectCourse";
		else
			return "ScreenSelectMusic";
		end;
	end;

	Branch = {
		TitleMenu = function()
			if GAMESTATE:GetCoinsNeededToJoin() > GAMESTATE:GetCoins() then
				return THEME:GetMetric( "Common", "InitialScreen" )
			end

			if GAMESTATE:GetCoinMode() == "CoinMode_Home" then return "ScreenTitleMenu" end
			return "ScreenTitleJoin"
		end,
		AfterProfileLoad = function()
			if ( THEME:GetMetric("Common","AutoSetStyle") == true ) then
				if IsNetConnected() then
					return "ScreenSelectStyle"
				else
					return "ScreenSelectMode"
				end
			else
				return "ScreenSelectMode"
			end
		end,
		AfterSelectPlayMode = function()
			if IsNetConnected() then
				ReportStyle()
				GAMESTATE:ApplyGameCommand("playmode,regular")
			end
			if IsNetSMOnline() then return SMOnlineScreen() end
			if IsNetConnected() then return "ScreenNetRoom" end
			return "ScreenSelectStyle"
		end,
		AfterSelectStyle = function()
			if CHARMAN:GetAllCharacters() ~= nil then
				return "ScreenSelectCharacter"
			else
				return "ScreenGameInformation"
			end
		end,
		AfterProfileSave = function()
			-- Might be a little too broken? -- Midiman
			if GAMESTATE:IsEventMode() then
				return SelectMusicOrCourse()
			elseif STATSMAN:GetCurStageStats():AllFailed() then
				return "ScreenGameOver"
			elseif GAMESTATE:GetSmallestNumStagesLeftForAnyHumanPlayer() == 0 then
				return "ScreenEvaluationSummary"
			else
				return SelectMusicOrCourse()
			end
		end,
		GetGameInformationScreen = function()
			bTrue = PREFSMAN:GetPreference("ShowInstructions");
			return (bTrue and GoToMusic() or "ScreenGameInformation");
		end,
		AfterSMOLogin = SMOnlineScreen(),
		BackOutOfPlayerOptions = function()
			return SelectMusicOrCourse()
		end,
		BackOutOfStageInformation = function()
			return SelectMusicOrCourse()
		end,
		AfterSelectMusic = function()
			if SCREENMAN:GetTopScreen():GetGoToOptions() then
				return SelectFirstOptionsScreen()
			else
				return "ScreenStageInformation"
			end
		end,
		PlayerOptions = function()
			local pm = GAMESTATE:GetPlayMode()
			local restricted = { "PlayMode_Oni", "PlayMode_Rave",
				--"PlayMode_Battle" -- ??
			};
			for i=1,#restricted do
				if restricted[i] == pm then
					if SCREENMAN:GetTopScreen():GetGoToOptions() then
						return "ScreenPlayerOptionsRestricted"
					else
						return "ScreenStageInformation"
					end;
				end;
			end
			if SCREENMAN:GetTopScreen():GetGoToOptions() then
				return "ScreenPlayerOptions";
			else
				return "ScreenStageInformation";
			end
		end,
		SongOptions = function()
			if SCREENMAN:GetTopScreen():GetGoToOptions() then
				return "ScreenSongOptions"
			else
				return "ScreenStageInformation"
			end
		end,
		AfterGameplay = function()
			-- pick an evaluation screen based on settings.
			if IsNetSMOnline() then
				return "ScreenNetEvaluation"
			else
				-- todo: account for courses etc?
				return "ScreenEvaluationNormal"
			end
		end,
		AfterEvaluation = function()
			if GAMESTATE:GetSmallestNumStagesLeftForAnyHumanPlayer() >= 1 then
				return "ScreenProfileSave"
			else
				return "ScreenEvaluationSummary"
			end
		end,
		AfterSummary = "ScreenProfileSaveSummary",
		Network = function()
			return IsNetConnected() and "ScreenTitleMenu" or "ScreenTitleMenu"
		end,
		NetworkConnect = function()
			if IsNetSMOnline() then return "ScreenReportStyle" end
			return "ScreenServerConnect";
		end,
		ReportStyle = function()
			if IsNetConnected() then ReportStyle() end
			if IsNetSMOnline() then return SMOnlineScreen() end
		end,
		ServerConnectNext = function()
			if IsNetConnected() then return "ScreenReportStyle" end
			if IsNetSMOnline() then return SMOnlineScreen() end
			return "ScreenSelectMode"; -- exiting while offline
		end,
	};
else -- add to sm-ssc's branch table
	Branch.AfterProfileLoad = function()
		if ( THEME:GetMetric("Common","AutoSetStyle") == true ) then
			if IsNetConnected() then
				return "ScreenSelectStyle"
			else
				return "ScreenSelectMode"
			end
		else
			return "ScreenSelectMode"
		end
	end
	Branch.NetworkConnect = function()
		if IsNetSMOnline() then return "ScreenReportStyle" end
		return "ScreenServerConnect";
	end;
	Branch.ReportStyle = function()
		if IsNetConnected() then ReportStyle() end
		if IsNetSMOnline() then return SMOnlineScreen() end
	end;
	Branch.ServerConnectNext = function()
		if IsNetConnected() then return "ScreenReportStyle" end
		if IsNetSMOnline() then return SMOnlineScreen() end
		return "ScreenSelectMode"; -- exiting while offline
	end;
	Branch.PlayerOptions = function()
		local pm = GAMESTATE:GetPlayMode()
		local restricted = { "PlayMode_Oni", "PlayMode_Rave",
			--"PlayMode_Battle" -- ??
		};
		for i=1,#restricted do
			if restricted[i] == pm then
				if SCREENMAN:GetTopScreen():GetGoToOptions() then
					return "ScreenPlayerOptionsRestricted"
				else
					return "ScreenStageInformation"
				end;
			end;
		end
		if SCREENMAN:GetTopScreen():GetGoToOptions() then
			return "ScreenPlayerOptions";
		else
			return "ScreenStageInformation";
		end;
	end;
end;